{***********************************************************************}
{           Pruebas de captura de mensajes del portapapeles             }
{                                                                       }
{               Copyright (C) 2003 por Neftal - Germn Estvez         }
{               E-mail: Neftali_GER@hotmail.com                         }
{***********************************************************************}
{ Este ejemplo puede ser distribuido libremente.                        }
{ ----------------------------------------------------------------------}
{ Version 1.01. Date last modified:  20/08/2003                         }
{ ----------------------------------------------------------------------}
unit FStringGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, Grids, ExtCtrls, StdCtrls, ComCtrls;

type
  TFormStringGrid = class(TForm)
    PanelGrid: TPanel;
    StringGrid1: TStringGrid;
    StatusBar1: TStatusBar;
    Panelbuttons: TPanel;
    sbImportar: TSpeedButton;
    sbCopiar: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    sbCortar: TSpeedButton;
    sbPegar: TSpeedButton;
    StatusBar2: TStatusBar;
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton4Click(Sender: TObject);
    procedure sbImportarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sbCopiarClick(Sender: TObject);
    procedure sbCortarClick(Sender: TObject);
    procedure sbPegarClick(Sender: TObject);
    procedure StatusBar2DblClick(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
    procedure __ParseLine(Str:String; TS:TStrings);    
    procedure __DeleteRow(SG: TStringGrid; Index:Integer);
  public
    { Public declarations }
  end;

const
  DATA_FILENAME = 'Data.csv';

var
  FormStringGrid: TFormStringGrid;

implementation

uses
  {Genericas} Clipbrd, StrUtils, ShellAPI,
  {Foms} FAbout{,
  cStrings};

{$R *.DFM}

procedure TFormStringGrid.SpeedButton3Click(Sender: TObject);
begin
  // cerrar
  Self.Close;
end;

procedure TFormStringGrid.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Liberamos
  Action := caFree;
end;

procedure TFormStringGrid.SpeedButton4Click(Sender: TObject);
var
  FormAbout: TFormAbout;
begin
  Application.CreateForm(TFormAbout, FormAbout);
  FormAbout.ShowModal;
end;

procedure TFormStringGrid.sbImportarClick(Sender: TObject);
var
  FileName:String;
  TS:TStringList;
  i:Integer;
  Str:String;
begin

  // Accedemos al fichero de datos
  FileName := ExtractFilePath(Application.ExeName);
  FileName := IncludeTrailingBackslash(FileName) + DATA_FILENAME;

  TS := TStringList.Create;

  // bloque de proteccion
  try
    TS.LoadFromFile(FileName);
    StringGrid1.RowCount := TS.Count + 1;

    for i := 0 to (TS.Count - 1) do  begin
      Str := TS.Strings[i];
      Str := AnsiReplaceStr(Str, ';', #10);
      StringGrid1.Rows[i].Text := Str;
    end;

  finally
    TS.Free;
  end;

  // Fila de ttulos fija
  if (StringGrid1.RowCount > 1) then begin
    StringGrid1.FixedRows := 1;
  end;
end;

procedure TFormStringGrid.FormShow(Sender: TObject);
begin
  // Inicialmente importamos los datos
  Self.sbImportarClick(Self);
end;

procedure TFormStringGrid.sbCopiarClick(Sender: TObject);
var
  i, j:Integer;
  Str:String;
begin

  // Inicializamos
  Str := '';
  // Para cada lnea de las selecciondas
  for i := (StringGrid1.Selection.Top) to (StringGrid1.Selection.Bottom) do begin
    // Si no es la 1 linea, aadimos un salto de lnea
    if (i <> StringGrid1.Selection.Top) then begin
      Str := Str + #13#10;
    end;
    // Para cada elemento dentro de la lnea (celdas)
    for j := 0 to (StringGrid1.Rows[i].Count - 1) do begin
      // Si no es la primera celda, aadimos un separados
      if (j <> 0) then begin
        Str := Str + ';';
      end;
      // Construimos la cadena
      Str := Str + StringGrid1.Rows[i].Strings[j];
    end;
    // La guardamos en el clipboard (como texto)
    Clipboard.AsText := Str
  end;

  MessageDlg('El contenido de la/s celda/s se ha copiado al portapapeles de windows', mtInformation, [mbOK], 0);

end;

procedure TFormStringGrid.sbCortarClick(Sender: TObject);
var
  Str: string;
  GRect: TGridRect;
  i, j: Integer;
begin

  // Inicializaciones
  GRect := StringGrid1.Selection;
  Str := '';
  // Para cada linea de la seleccion
  for i := GRect.Top to GRect.Bottom do begin
    // Hay que aadir separador?
    if (j = GRect.Right) then begin
      Str := Str + (StringGrid1.Rows[i].Text);
    end
    else begin
      Str := Str + StringGrid1.Rows[i].Text;
    end;
    Str := AnsiReplaceStr(Str, #13#10, ';');
    // Salto de linea
    Str := Str + #13#10;
  end;
  // Copiar al portapapeles
  ClipBoard.AsText := Str;

  // Borrar todas las lneas
  for i := GRect.Bottom downto GRect.Top do begin
    __DeleteRow(StringGrid1, i);
  end;
  
end;

procedure TFormStringGrid.__DeleteRow(SG: TStringGrid; Index:Integer);
var
  i:Integer;
begin

  // Slo est la de ttulos?
  if (SG.RowCount = 1) then begin
    Exit;
  end;

  for i := Index to (SG.RowCount) do begin
    SG.Rows[i].Assign(SG.Rows[i+1]);
  end;

  // No quedan Lneas?
  if (SG.RowCount > 1) then begin
    SG.RowCount := SG.RowCount - 1;
  end
  else begin

  end;

end;

procedure TFormStringGrid.__ParseLine(Str:String; TS:TStrings);
var
  tmp:String;
begin

  // Elimiar el dalto de linea final
  Str := AnsiReplaceText(Str, #13#10, '');

  // Mientras haya lineas
  while (Str <> '') do begin

    if (Pos(';', Str) <> 0) then begin
      tmp := Copy(Str, 1, Pos(';', Str)-1);
      Str := Copy(Str, Pos(';', Str)+1, Length(Str));
    end
    else begin
      tmp := Str;
      Str := '';
    end;
    TS.Add(tmp);
  end;
end;

procedure TFormStringGrid.sbPegarClick(Sender: TObject);
var
  TS:TStrings;
  Path:String;
  i: Integer;
  Str, tmp:String;
begin

  // Recupar el texxto del portapepeles
  Str := ClipBoard.AsText;
  // Lo dicidimos en lineas y lo pasamos a RS
  i := Pos(#13#10, Str);
  TS:= TStringList.Create;
  // Separar las lineas...
  while (i > 0) do begin
    tmp := Copy(Str, 1, i-1);
    TS.Add(tmp);
    tmp := Copy(Str, i+2, Length(Str));
    Str := tmp;
    i := Pos(#13#10, Str);
  end;
  // Aadimos el resto...
  if (Str <> '') then begin
    TS.Add(Str);
  end;

  try
    // Parsear las lneas y pegarlas al grid
    for i := 0 to (TS.Count - 1) do begin
      Str := Trim(TS[i]);
      StringGrid1.RowCount := StringGrid1.RowCount + 1;
      __ParseLine(Str, StringGrid1.Rows[StringGrid1.RowCount - 1])
    end;

  finally
    TS.Free;
  end;

  // Lineas aadidas
  Self.StringGrid1.FixedRows := 1;

end;

procedure TFormStringGrid.StatusBar2DblClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://neftali.clubdelphi.com/', 0, 0, 0);
end;

procedure TFormStringGrid.StringGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);


   //
   procedure WriteText(StringGrid: TStringGrid; ACanvas: TCanvas; const ARect: TRect;
     const Text: string; Format: Word);
   const
     DX = 2;
     DY = 2;
   var
     S: array[0..255] of Char;
     B, R: TRect;
   begin
     with Stringgrid, ACanvas, ARect do
     begin
       case Format of
         DT_LEFT: ExtTextOut(Handle, Left + DX, Top + DY,
             ETO_OPAQUE or ETO_CLIPPED, @ARect, StrPCopy(S, Text), Length(Text), nil);

         DT_RIGHT: ExtTextOut(Handle, Right - TextWidth(Text) - 3, Top + DY,
             ETO_OPAQUE or ETO_CLIPPED, @ARect, StrPCopy(S, Text),
             Length(Text), nil);

         DT_CENTER: ExtTextOut(Handle, Left + (Right - Left - TextWidth(Text)) div 2,
             Top + DY, ETO_OPAQUE or ETO_CLIPPED, @ARect,
             StrPCopy(S, Text), Length(Text), nil);
       end;
     end;
   end;
   //
   procedure Display(StringGrid: TStringGrid; const S: string; Alignment: TAlignment;
                     BackColor:TColor=-1; OnlyColor:Boolean=False);
   const
     Formats: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
   var
     _Align:TAlignment;
   begin
      // Fila fija?  ==> Salimos
      if (ARow < StringGrid.FixedRows) then begin
        Exit;
      end;

      // Color diferente de -1?
      if (BackColor <> -1) and (not (gdSelected in State)) then begin
        StringGrid.Canvas.Brush.Style := bsSolid;
        StringGrid.Canvas.Brush.Color := BackColor;
        StringGrid.Canvas.FillRect(Rect);
      end;

      // asignado
      _Align := Alignment;

      // Slo color?
      if not (OnlyColor) then begin
        _Align := taLeftJustify;
      end;

      // Texto
      WriteText(StringGrid, StringGrid.Canvas, Rect, S, Formats[_Align]);
   end;
   //


begin


  // Linea 7 de color Verde
  if Arow = 7 then begin
    Display(StringGrid1, StringGrid1.Cells[ACol, ARow], taLeftJustify, clMoneyGreen, True);
  end;
  
  // La columna 0 a la derecha
  if ACol = 0 then begin
    Display(StringGrid1, StringGrid1.Cells[ACol, ARow], taRightJustify);
  end;

  // La columna 1 a la centrada
  if ACol = 1 then begin
    Display(StringGrid1, StringGrid1.Cells[ACol, ARow], taCenter, clSkyBlue);
  end;

end;

end.
